/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-config-support
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.config.runtime;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.component.ComponentContext;
import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Deactivate;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import ru.entaxy.platform.base.objects.EntaxyObject;
import ru.entaxy.platform.base.objects.EntaxyObjectService;
import ru.entaxy.platform.core.producer.executor.objectmodel.FactoredObjectRef;

@Component(service = ObjectConfigHelper.class, immediate = true)
public class ObjectConfigHelper {

    private static ObjectConfigHelper _INSTANCE = null;

    public static ObjectConfigHelper getInstance() {
        return _INSTANCE;
    }

    @Reference(cardinality = ReferenceCardinality.MANDATORY)
    EntaxyObjectService entaxyObjectService;

    public BundleContext bundleContext;

    public ObjectConfigHelper() {
        super();
        _INSTANCE = this;
    }

    @Activate
    public void activate(ComponentContext componentContext) {
        this.bundleContext = componentContext.getBundleContext();
    }

    @Deactivate
    public void deactivate() {

    }

    public EntaxyObject findObject(String objectId, String objectType) {
        return entaxyObjectService.findObject(objectId, objectType);
    }

    public boolean isDirectValueOnly(FactoredObjectRef ref) {
        if (!ref.origin.has(ObjectConfig.DIRECT_VALUE_ONLY_ATTR_NAME))
            return false;
        try {
            return ref.origin.get(ObjectConfig.DIRECT_VALUE_ONLY_ATTR_NAME).getAsBoolean();
        } catch (Exception e) {
            return false;
        }
    }

    public <S> ServiceReference<S> getReference(Class<S> clazz) {
        if (bundleContext == null)
            return null;
        return bundleContext.getServiceReference(clazz);
    }

    public <T> T getService(ServiceReference<T> ref) {
        return (T) bundleContext.getService(ref);
    }

    public void ungetService(ServiceReference<?> ref) {
        if (bundleContext == null)
            return;
        bundleContext.ungetService(ref);
    }

}
